      subroutine activateWindow(nr,ier)
      integer nr
      integer ier
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      if(nr.le.0.or.nr.gt.maxwindow) then
        call windowloginteger(wLOgErr,nr,
     +       'ActivateWindow: nr # out of range')
        ier = 1
        return
      endif
      if(nr.eq.ActiveWindow) then
        call WindowLogInteger(wLogInfo,nr,'Window # already active')
        ier = 0
        return
      endif
      if(.not.WindowUsed(nr)) then
        call WindowLogInteger(wLogErr,nr,'Window # does not exist')
        ier = 1
        return
      endif
      if(ActiveWorld.gt.0) then
        call WindowLogInteger(wLogInfo,ActiveWorld,
     +       'Deactivating World #')
        ActiveWorld = -1
      endif
      ActiveWindow = nr
      if(IsPixmap(nr)) then
        call WindowLogInteger(wLogInfo,nr,'Activating Pixmap #')
        call pactivate(ActiveWindow)
      else
        call WindowLogInteger(wLogInfo,nr,'Activating Window #')
        call wactivate(ActiveWindow)
      endif
      ier = 0
      return
      end                       ! ActivateWindow
      subroutine ActivateWorld(nr,ier)
      integer   nr
      integer   ier
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      if(nr.eq.ActiveWorld) then
        call WindowLogInteger(wLogInfo,nr,'World # already active')
        ier = 0
      endif
      call WindowLogInteger(wLogInfo,nr,'Activating World #')
      if(nr.ge.1.and.nr.le.MaxWorld) then
        call activateWindow(WorldParent(nr),ier)
        if(ier.ne.0) then
          activeworld = -1
          call windowlogInteger(wLogErr,nr,
     +         'ActivateWorld: world # has no corresponding window')
          return
        endif
        ActiveWorld = nr
        call windowloginteger(wLogInfo,ActiveWorld,'Active World=#')
        ier = 0
      else
        call windowloginteger(wLogErr,nr,
     +       'ActivateWorld #: out of range')
        ier = 1
        ActiveWorld = -1
      endif
      return
      end                       ! ActivateWorld
      subroutine AddPixel(nx,ny)
      integer nx
      integer ny
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      if(ipoint.lt.maxpoint) then
        ipoint = ipoint + 1
        xy(2*ipoint-1) = nx
        xy(2*ipoint) = ny
      endif
      return
      end                       ! AddPixel
      subroutine AddPoint(x,y)
      real    x
      real    y
      integer nx
      integer ny
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      if(ActiveWorld.lt.0) then
        call windowCannot('AddPoint')
        return
      endif
      call WorldToWindow(x,y,nx,ny)
      call AddPixel(nx,ny)
      return
      end                       ! AddPoint
      subroutine CheckPixmap(p,ier)
      integer p
      integer ier
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      if(p.le.0.or.p.gt.maxWindow) then
        call windowloginteger(wLOgErr,p,
     +       'Error: pixmap # out of range')
        ier = 1
        return
      endif
      if(.not.WindowUsed(p)) then
        call WindowLogInteger(wLogErr,p,
     +       'Error: pixmap # does not exist')
        ier = 1
        return
      endif
      if(.not.IsPixmap(p)) then
        call WindowLogInteger(wLogErr,p,
     +       'Error: pixmap # is not a pixmap')
        ier = 1
        return
      endif
      ier = 0
      return
      end                       ! CheckPixmap
      subroutine ClearPoint
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      ipoint = 0
      return
      end                       ! ClearPoint
      subroutine ClearWindow
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      if(ActiveWorld.lt.0) then
        call WindowCannot('Clear')
        return
      endif
      if(ActiveWindow.gt.0) then
        if(IsPixmap(ActiveWindow)) then
          call SetColourDirect(WindowBG(ActiveWindow))
          if(loglevel.ge.wLogNotice) then
            call str_integer_out(activeWindow,'Cleared pixmap #')
          endif
          call wfillrectangle(WindowWidth(ActiveWindow),
     +         WindowHeight(ActiveWindow))
        else
          if(loglevel.ge.wLogNotice) then
            call str_integer_out(ActiveWindow,'Cleared Window #')
          endif
          call wclear
        endif
      endif
      return
      end                       ! ClearWindow
      subroutine CreatePixmap(pnr,wnr,ier)
      integer pnr
      integer wnr
      integer ier
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      if(loglevel.ge.wLogNotice) then
        call str_integer_out(pnr,'CreatePixmap #')
        call str_integer_out(wnr,'on window #')
      endif
      if(pnr.le.0.or.pnr.gt.maxwindow) then
        call windowloginteger(wLOgErr,pnr,
     +       'CreatePixmap: nr # out of range')
        ier = 1
        return
      endif
      if(WindowUsed(pnr)) then
        call WindowLogInteger(wLogErr,pnr,'Pixmap # already exists')
        ier = 1
        return
      endif
      call ActivateWindow(wnr,ier)
      if(ier.ne.0) return
      WindowUsed(pnr) = .true.
      WindowWidth(pnr)  = WindowWidth(wnr)
      WindowHeight(pnr) = WindowHeight(wnr)
      WindowHor(pnr) = WindowHor(wnr)
      WindowVer(pnr) = WindowVer(wnr)
      WindowVerX(pnr) = WindowVerx(wnr)
      WindowBG(pnr) = WindowBG(wnr)
      WindowParent(pnr) = wnr
      IsPixmap(pnr) = .true.
      call wpixmap(pnr,wnr,WindowWidth(pnr),windowheight(pnr))
      ier = 0
      return
      end
      subroutine CreateSubWindow(nr1,nr2,llx,lly,sx,sy,border,
     +     colour,ier)
      integer   nr1
      integer   nr2
      integer   llx
      integer   lly
      integer   sx
      integer   sy
      integer   border
      character colour*(*)
      integer   ier
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer   bg,fg
      if(loglevel.ge.wLogNotice) then
        call str_integer_out(nr1,'CreateSubWindow #')
        call str_integer_out(nr2,'on #')
        call str_2integer_out(llx,lly,'LL= #,#')
        call str_2integer_out(sx,sy,'Size= #,#')
        call str_integer_out(border,'border=#')
        call str_string_out(colour,'bgcolour=#')
      endif
      if(nr1.gt.maxwindow) then
        call WindowLogInteger(wLogErr,nr1,
     +       'CreateSubWindow #: out of range')
        ier = 1
        return
      endif
      if(.not.WindowUsed(nr2)) then
        call WindowLOgInteger(wLOgErr,nr2,
     +       'CreateSubWindow: parent # does not exist')
        ier = 1
        return
      endif
      if(WindowUsed(nr1)) then
        call DeleteWindow(nr1)
        call WindowSync ! xxxxxxxxxxxxxxxxxxxx
      endif
      WindowWidth(nr1)  = sx
      WindowHeight(nr1) = sy
      WindowParent(nr1) = nr2
      WindowHor(nr1) = llx
      WindowVer(nr1) = lly
      WindowVerX(nr1) = WindowHeight(nr2) - lly - sy - (2*border)
      if(loglevel.ge.wLogNotice) then
        call str_3integer_out(WindowHor(nr1),WindowVer(nr1),
     +       WindowVerX(nr1),'Hor=# Ver=# VerX=#')
        call str_2integer_out(WindowWidth(nr1),WindowHeight(nr1),
     +       'w=# h=#')
      endif
      call GetColour(colour,bg)
      call GetColour('WHITE',fg)
      if(loglevel.ge.wLOgDebug) call str_out('before wopen')
      call wactivate(nr2)
      call wsubopen(nr1,WindowHor(nr1),WindowVerX(nr1),
     +     WindowWidth(nr1),WindowHeight(nr1),border,fg,bg)
      if(loglevel.ge.wLogDebug) call str_out('after wopen')
      WindowUsed(nr1) = .true.
      WindowBG(nr1) = bg
      activewindow = -1
      call ActivateWindow(nr1,ier)
      if(loglevel.ge.wLogNotice) then
        call str_flush
      endif
      ier = 0
      return
      end                       ! CreateSubWindow
      subroutine CreateWindow(nr,title,llx,lly,sx,sy,colour,ier)
      integer   nr
      character title*(*)
      integer   llx
      integer   lly
      integer   sx
      integer   sy
      character colour*(*)
      integer   ier
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer length
      character name*80
      integer   ln
      integer   lt
      integer   bg,fg
      call InitWindow(ier)
      if(ier.ne.0) return
      if(loglevel.ge.wLogNotice) then
        call str_integer_out(nr,'CreateWindow #')
        call str_out(title)
        call str_2integer_out(llx,lly,'LL= #,#')
        call str_2integer_out(sx,sy,'Size= #,#')
        call str_string_out(colour,'bgcolour=#')
      endif
      if(nr.gt.maxwindow) then
        call windowloginteger(wLOgErr,nr,
     +       'CreateWindow: nr # out of range')
        ier = 1
        return
      endif
      if(WindowUsed(nr)) then
        call DeleteWindow(nr)
      endif
      WindowWidth(nr)  = sx
      WindowHeight(nr) = sy
      WindowHor(nr) = llx
      WindowVer(nr) = lly
      WindowVerX(nr) = screen_height - lly - sy
      WindowParent(nr) = 0
      IsPixmap(nr) = .false.
      if(loglevel.ge.wLogNotice) then
        call str_3integer_out(WindowHor(nr),WindowVer(nr),
     +       WindowVerX(nr),'Hor=# Ver=# VerX=#')
        call str_2integer_out(WindowWidth(nr),WindowHeight(nr),
     +       'w=# h=#')
      endif
      call GetColour(colour,bg)
      call GetColour('WHITE',fg)
      if(loglevel.ge.wLogDebug) call str_out('before wopen')
      call wopen(nr,WindowHor(nr),WindowVerX(nr),WindowWidth(nr),
     +     WindowHeight(nr),fg,bg)
      if(loglevel.ge.wLogDebug) call str_out('after wopen')
      WindowUsed(nr) = .true.
      ActiveWindow = nr
      WindowBG(nr) = bg
      lt = length(title)
      if(lt.eq.0) then
        call image_name(name,ln)
      else
        name = title
        ln = lt
      endif
      call str_zero(name,name,ln)
      call wtitle(name(1:ln))
      if(loglevel.ge.wLogNotice) then
        call str_flush
      endif
      activewindow = -1
      call ActivateWindow(nr,ier)
      ier = 0
      return
      end                       ! CreateWindow
      subroutine CreateWorld(nr,windownr,llx,lly,urx,ury,ier)
      integer   nr       ! world number
      integer   WindowNr ! window number
      real      llx      ! world x coordinate Lower Left
      real      lly      ! world y coordinate Lower Left
      real      urx      ! world x coordinate Upper Right
      real      ury      ! world y coordinate Upper Right
      integer   ier
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      if(nr.gt.MaxWorld) then
        call WindowLogInteger(wLogErr,nr,'CreateWorld #: out of range')
        ier = 1
        return
      endif
      if(.not.WindowUsed(WindowNr)) then
        call WindowLogInteger(wLogErr,nr,'CreateWorld #')
        call WindowLogInteger(wLOgErr,windownr,
     +       'Window # is not available')
        ier = 1
        return
      endif
      if(loglevel.ge.wLOgNotice) then
        call str_integer_out(nr,'CreateWorld #:')
        call str_integer_out(windownr,'window #')
        call str_2real_out(llx,lly,'LL=# #')
        call str_2real_out(urx,ury,'UR=# #')
        call str_integer_out(windowwidth(WindowNr),'w=#')
        call str_integer_out(windowheight(WindowNr),'h=#')
      endif
      if(urx-llx.le.0.0.or.ury-lly.le.0.0) then
        call WindowLogInteger(wLogErr,nr,'CreateWorld #')
        call WindowLog(wLogErr,'World with zero range')
        ier = 1
        return
      endif
      scalx(nr) = WindowWidth(WindowNr)/(urx-llx)
      scaly(nr) = WindowHeight(WindowNr)/(ury-lly)
      offsx(nr) = llx
      offsy(nr) = lly
      topx(nr) = urx
      topy(nr) = ury
      WorldParent(nr) = WindowNr
      if(loglevel.ge.wLogNotice) then
        call str_2real_out(scalx(nr),scaly(nr),'Scale # #')
        call str_2real_out(offsx(nr),offsy(nr),'Offsets # #')
        call str_flush
      endif
      call ActivateWorld(nr,ier)
      return
      end                       ! CreateWorld
      subroutine DeleteWindow(nr)
      integer nr
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer i
      if(WindowUsed(nr)) then
        if(IsPixmap(nr)) then
          call WindowLogInteger(wLogNotice,nr,'Deleted pixmap #')
          call pdelete(nr)
        else
          call WindowLogInteger(wLogNotice,nr,'Deleted window #')
          call wclose(nr)
        endif
        WindowUsed(nr) = .false.
        do i=1,maxworld
          if(WorldParent(i).eq.nr) then
            WorldParent(i) = 0
            if(ActiveWorld.eq.i) ActiveWorld = -1
          endif
        enddo
        if(ActiveWindow.eq.nr) ActiveWindow = -1
        do i=1,maxwindow
          if(WindowParent(i).eq.nr) then
            WindowUsed(i) = .false.
            if(ActiveWindow.eq.i) ActiveWindow = -1
          endif
        enddo
      endif
      return
      end                       ! DeleteWindow
      subroutine DrawArc(x,y,radius,start,size)
      real      x
      real      y
      real      radius
      real      start  ! radians
      real      size ! radians
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      real      Pi
      real      Grad
      parameter (Pi=3.1415927)
      parameter (Grad = 180.0/Pi)
      integer   nx
      integer   ny
      integer   hx,hy
      integer   halfrad
      integer   fullrad
      if(ActiveWorld.lt.0) then
        call WindowCannot('DrawArc')
        return
      endif
      call WorldToWindow(x,y,nx,ny)
      call WorldToWindow(x+radius,y,hx,hy)
      halfrad = abs(hx-nx)
      fullrad = 2*halfrad
      if(fullrad.le.0) then
        call WindowLog(wLogWarning,'DrawArc with zero radius')
      else
        call wdrawarc(nx-halfrad,ny-halfrad,fullrad,fullrad,
     +       nint(start*grad*64),nint(size*grad*64))
      endif
      return
      end                       ! DrawArc
      subroutine DrawCenteredString(x,y,s)
      real      x
      real      y
      character s*(*)
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer   length
      integer nx
      integer ny
      if(ActiveWorld.lt.0) then
        call WindowCannot('DrawCenteredString')
        return
      endif
      call WorldToWindow(x,y,nx,ny)
      if(loglevel.ge.wLogDebug) then
        call str_2real_out(x,y,'DrawCenteredString (#,#)')
        call str_2integer_out(nx,ny,'[#,#]')
        call str_out(s)
      endif
      call wdrawcenteredstring(nx,ny,length(s),s)
      return
      end                       ! DrawCenteredString
      subroutine DrawCircle(x,y,radius)
      real      x
      real      y
      real      radius
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      real      TwoPi
      parameter (TwoPi=2*3.1415927)
      call DrawArc(x,y,radius,0.0,TwoPi)
      return
      end                       ! DrawCircle
      subroutine DrawCornerString(x,y,corner,s)
      real      x
      real      y
      character corner*2
      character s*(*)
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer   length
      integer   nx
      integer   ny
      character message*80
      if(ActiveWorld.lt.0) then
        call WindowCannot('DrawCornerString')
        return
      endif
      call WorldToWindow(x,y,nx,ny)
      if(loglevel.ge.wLogDebug) then
        call str_2real_out(x,y,'DrawCornerString (#,#)')
        call str_2integer_out(nx,ny,'[#,#]')
        call str_out(s)
      endif
      if(corner.eq.'LL') then
        call wdrawcornerstring(nx,ny,1,length(s),s)
      else if(corner.eq.'LR') then
        call wdrawcornerstring(nx,ny,2,length(s),s)
      else if(corner.eq.'UR') then
        call wdrawcornerstring(nx,ny,3,length(s),s)
      else if(corner.eq.'UL') then
        call wdrawcornerstring(nx,ny,4,length(s),s)
      else
        call str_string(corner,'DrawCornerString # unknown',message)
        call WindowLog(wLogWarning,message)
      endif
      return
      end                       ! DrawTopRightString
      subroutine DrawFatPoint(x,y,n)
      real    x
      real    y
      integer n
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer px
      integer py
      integer n1
      integer n2
      if(ActiveWorld.lt.0) then
        call WindowCannot('DrawFatPoint')
        return
      endif
      if(n.le.1) then
        call DrawPoint(x,y)
      else
        call WorldToWindow(x,y,px,py)
        call ClearPoint
        n1 = -(n-1)/2
        n2 = n1+n  ! -1+1 Note fill leaves out bottom and right side
        if(loglevel.ge.wLogDebug) then
          call str_integer_out(n,'DrawFatPoint #')
          call str_2real_out(x,y,'(#,#)')
          call str_2integer_out(px,py,'[#,#]')
        endif
        call AddPixel(px+n1,py+n1)
        call AddPixel(px+n2,py+n1)
        call AddPixel(px+n2,py+n2)
        call AddPixel(px+n1,py+n2)
        call FillPolygon
      endif
      return
      end ! DrawFatPoint
      subroutine DrawLine(x1,y1,x2,y2)
      real x1
      real y1
      real x2
      real y2
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer nx1
      integer ny1
      integer nx2
      integer ny2
      if(ActiveWorld.lt.0) then
        call WindowCannot('DrawLine')
        return
      endif
      call WorldToWindow(x1,y1,nx1,ny1)
      call WorldToWindow(x2,y2,nx2,ny2)
      if(loglevel.ge.wLogDebug) then
        call str_2real_out(x1,y1,'DrawLine (#,#)')
        call str_2real_out(x2,y2,'- (#,#)')
        call str_2integer_out(nx1,ny1,'[#,#]')
        call str_2integer_out(nx2,ny2,'- [#,#]')
      endif
      call wdrawline(nx1,ny1,nx2,ny2)
      return
      end                       ! DrawLine
      subroutine DrawLines
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      if(ActiveWorld.lt.0) then
        call WindowCannot('DrawLines')
        return
      endif
      if(loglevel.ge.wLogDebug) then
        call str_integer_out(ipoint,'DrawLines #')
      endif
      if(ipoint.gt.0) then
        call wdrawlines(ipoint,xy(1))
      endif
      return
      end                       ! DrawLines
      subroutine DrawPoint(x,y)
      real x
      real y
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer nx
      integer ny
      if(ActiveWorld.lt.0) then
        call WindowCannot('DrawPoint')
        return
      endif
      call WorldToWindow(x,y,nx,ny)
      if(loglevel.ge.wLogDebug) then
        call str_2real_out(x,y,'DrawPoint (#,#)')
        call str_2integer_out(nx,ny,'[#,#]')
      endif
      call wdrawpoint(nx,ny)
      return
      end                       ! DrawPoint
      subroutine DrawString(x,y,s)
      real      x
      real      y
      character s*(*)
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer   length
      integer nx
      integer ny
      if(ActiveWorld.lt.0) then
        call WindowCannot('DrawString')
        return
      endif
      call WorldToWindow(x,y,nx,ny)
      if(loglevel.ge.wLogDebug) then
        call str_2real_out(x,y,'DrawString (#,#)')
        call str_2integer_out(nx,ny,'[#,#]')
        call str_out(s)
      endif
      call wdrawstring(nx,ny,length(s),s)
      return
      end                       ! DrawString
      subroutine FillArc(x,y,radius,start,size)
      real      x
      real      y
      real      radius
      real      start           ! radians
      real      size            ! radians
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      real      Pi
      real      Grad
      parameter (Pi=3.1415927)
      parameter (Grad = 180.0/Pi)
      integer   nx
      integer   ny
      integer   hx
      integer   hy
      integer   halfrad
      integer   fullrad
      if(ActiveWorld.lt.0) then
        call WindowCannot('FillArc')
        return
      endif
      call WorldToWindow(x,y,nx,ny)
      call WorldToWindow(x+radius,y,hx,hy)
      halfrad = abs(hx-nx)
      fullrad = 2*halfrad
      if(fullrad.le.0) then
        call WindowLog(wLogWarning,'FillArc with zero radius')
      else
        call wfillarc(nx-halfrad,ny-halfrad,fullrad,fullrad,
     +       nint(start*grad*64),nint(size*grad*64))
      endif
      return
      end                       ! FillArc
      subroutine FillCircle(x,y,radius)
      real      x
      real      y
      real      radius
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      real      TwoPi
      parameter (TwoPi=2*3.1415927)
      call FillArc(x,y,radius,0.0,TwoPi)
      return
      end                       ! FillCircle
      subroutine FillPolygon
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      if(ActiveWorld.lt.0) then
        call WindowCannot('FillPolygon')
        return
      endif
      if(loglevel.ge.wLogDebug) then
        call str_integer_out(ipoint,'FillPolygon #')
      endif
      if(ipoint.gt.0) then
        call wfillpolygon(ipoint,xy(1))
      endif
      return
      end                       ! FillPolygon
      subroutine GetColour(colourname,colourcode)
      character colourname*(*)
      integer   colourcode
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      character s*80
      integer   ls
      if(loglevel.ge.wLogInfo) then
        call str_string_out(colourname,'GetColour #')
      endif
      if(colourname.eq.lastcolourname) then
        colourcode = lastcolourcode
        if(loglevel.ge.wLogInfo) then
          call str_out('identical')
        endif
      else
        call str_zero(colourname,s,ls)
        call wgetcolour(s(1:ls),colourcode)
        if(colourcode.lt.0) then
          if(loglevel.ge.wLogErr) then
            call str_out('Cannot load colour')
            call str_out(colourname)
          endif
        else
          if(loglevel.ge.wLogInfo) then
            call str_integer_out(colourcode,'code=#')
          endif
          lastcolourname  = colourname
          lastcolourcode = colourcode
        endif
      endif
      return
      end                       ! GetColour
      subroutine GetWindowId(windownr,result)
      integer windownr
      integer result
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      if(.not.WindowUsed(WindowNr)) then
        result = -1
      else
        call wwindowid(windownr,result)
      endif
      return
      end                       ! GetWindowId
      subroutine InitWindow(ier)
      integer   ier
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer requestsize
      integer i
      if(.not.display_activated) then
        do i=1,MaxWindow
          WindowUsed(i) = .false.
        enddo
        do i=1,MaxWorld
          WorldParent(i) = 0
        enddo
        call winit(ier,screen_width,screen_height,requestsize)
        if(ier.ne.0) then
          call windowlog(wLogErr,'Cannot open display')
          return
        endif
        display_activated = .True.
        ActiveWorld = -1
        ActiveWindow = -1
        LastColourCode=-1
        LastColourName = ' '
        LastColourSet = -1
      else
        ier = 0
      endif
      return
      end                       ! InitWindow
      subroutine MapPixmap(pnr,ier)
      integer pnr
      integer ier
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer  wnr
      call CheckPixmap(pnr,ier)
      if(ier.ne.0) return
      wnr = WindowParent(pnr)
      if(loglevel.ge.wLogNotice) then
        call str_2integer_out(pnr,wnr,'pixmap # => window #')
      endif
      call wmappixmap(pnr,wnr,WindowWidth(pnr),WindowHeight(pnr))
      ier = 0
      return
      end                       ! MapPixmap
      subroutine ResizeWindow(w,h)
      integer w,h
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer  i
      real     fx,fy
      integer  shift
      if(ActiveWindow.lt.0) then
        call WindowCannot('Resize')
        return
      endif
      if(loglevel.ge.wLogNotice) then
        call str_integer_out(ActiveWindow,'Resize window #')
        call str_2integer_out(w,h,'w=# h=#')
        call str_flush
      endif
      fx = float(w)/WindowWidth(ActiveWindow)
      fy = float(h)/WindowHeight(ActiveWindow)
      do i=1,maxworld
        if(WorldParent(i).eq.ActiveWindow) then
          scalx(i) = fx*scalx(i)
          scaly(i) = fx*scaly(i)
        endif
      enddo
      shift = h - WindowHeight(ActiveWindow)
      WindowVerX(ActiveWindow) = WindowVerX(ActiveWindow) - shift
      WindowWidth(ActiveWindow) = w
      WindowHeight(ActiveWindow) = h
      call wresize(WindowWidth(ActiveWindow),WindowHeight(ActiveWindow))
      return
      end                       ! ResizeWindow
      subroutine ScreenDimensions(x,y)
      integer   x
      integer   y
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer   ier
      call InitWindow(ier)
      if(ier.ne.0) then
        x = 0
        y = 0
      else
        x = screen_width
        y = screen_height
      endif
      return
      end                       ! ScreenDimensions
      subroutine SetColourDirect(colourcode)
      integer colourcode
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      if(colourcode.ne.lastcolourset) then
        call wsetcolour(colourcode)
        lastcolourset = colourcode
        if(loglevel.ge.wLogInfo) then
          call str_integer_out(colourcode,'SetColourDirect #')
        endif
      else
        if(loglevel.ge.wLogInfo) then
          call str_integer_out(colourcode,'SetColourDirect # identical')
        endif
      endif
      return
      end                       ! SetColourDirect
      subroutine SetWindowLog(n)
      integer n
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      loglevel = n
      if(loglevel.ge.wLogInfo) then
        call str_integer_out(loglevel,'Window loglevel=#')
      endif
      return
      end
      subroutine WindowCannot(s)
      character s*(*)
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      if(loglevel.ge.wLogErr) then
        call str_string_out(s,'Cannot #. Inactive World')
      endif
      return
      end
      block data windowdata
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      data display_activated /.false./
      data loglevel /wLogWarning/
      end
      subroutine WindowExit
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer i
      if(display_activated) then
        do i=1,maxwindow
          if(WindowUsed(i).and.WindowParent(i).eq.0) then
            call wclose(i)
          endif
        enddo
        call wend
      endif
      return
      end                       ! WindowExit
      subroutine WindowInfo(unit)
      integer   unit
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer   i,j
      call str_unit_push(unit)
      call wdisplayinfo
      do i=1,MaxWindow
        if(WindowUsed(i)) then
          call str_integer_out(i,'Window #')
          call str_integer_out(WindowParent(i),'Parent=#')
          if(IsPixmap(i)) then
            call str_out('Pixmap')
          else
            call str_integer_out(WindowHor(i),'Hor=#')
            call str_integer_out(WindowVer(i),'Ver=#')
            call str_integer_out(WindowVerX(i),'VerX=#')
          endif
          call str_integer_out(WindowWidth(i),'Width=#')
          call str_integer_out(WindowHeight(i),'Height=#')
          call str_integer_out(WindowBG(i),'BG=#')
          if(i.eq.activewindow) call str_out('Active')
          call str_flush
          if(.not.IsPixmap(i)) then
            call winfo(i)
          endif
          do j=1,MaxWorld
            if(WorldParent(j).eq.i) then
              call str_integer_out(j,'World #:')
              call str_real_out(offsx(j),'Offset hor=#')
              call str_real_out(offsy(j),'ver=#.')
              call str_real_out(scalx(j),'Scale hor=#')
              call str_real_out(scaly(j),'ver=#.')
              if(j.eq.ActiveWorld) call str_out('Active')
              call str_flush
            endif
          enddo
        endif
      enddo
      call str_unit_pop
      return
      end                       ! WindowInfo
      subroutine WindowLog(level,message)
      integer   level
      character message*(*)
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      if(loglevel.ge.level) then
        call str_out(message)
      endif
      return
      end
      subroutine WindowLogInteger(level,n,message)
      integer   level
      integer   n
      character message*(*)
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      if(loglevel.ge.level) then
        call str_integer_out(n,message)
      endif
      return
      end
      subroutine WindowPs(name,windownr,ier)
      character name*(*)
      integer   windownr
      integer   ier
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer   id
      character string*80
      character line*80
      integer   ls
      call GetWindowId(windownr,id)
      if(id.lt.0) then
        call WindowLogInteger(wLogErr,windownr,
     +       'WindowPs: cannot get windowid of #')
        ier = 1
        return
      endif
      call build_file(name,'import','.ps',string,ls)
      call rename_unique_file(string)
      line = 'import -verbose -page A4 -frame -window # #'
      call str_integer(id,line,line)
      call str_string(string,line,line)
      if(loglevel.ge.wLogNotice) call str_out(line)
      call spawn(line,ier)
      ier = 0
      return
      end                       ! WindowPs
      subroutine WindowSync
      call wflush
      call wsync
      return
      end                       ! WindowSync
      subroutine WindowTitle(s)
      character s*(*)
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      character title*80
      integer   lt
      integer   i
      integer   ier
      integer   KeepActiveWorld
      if(ActiveWorld.lt.0) then
        call WindowCannot('set title')
        return
      endif
      KeepActiveWorld = ActiveWorld
      call str_zero(s,title,lt)
      i = WorldParent(ActiveWorld)
      do while(WindowParent(i).gt.0)
        i = WindowParent(i)
      enddo
      call ActivateWindow(i,ier)
      if(ier.eq.0) then
        if(loglevel.ge.wLogInfo) then
          call str_integer_out(i,'Window #')
          call str_string_out(s,'title=#')
        endif
        call wtitle(title(1:lt))
        call WindowSync
      endif
      activeworld = -1
      call ActivateWorld(KeepActiveWorld,ier)
      return
      end                       ! WindowTitle
      subroutine WorldToWindow(x,y,nx,ny)
      real    x
      real    y
      integer nx
      integer ny
      integer maxwindow
      parameter (maxwindow=50)  ! nb ook veranderen in x.c
      integer maxworld
      parameter (maxworld=2*maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      integer ActiveWorld
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      integer ActiveWindow
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      logical IsPixmap(maxwindow)
      integer screen_width,screen_height
      integer lastcolourcode
      integer lastcolourset
      common /CommonWindow/ ActiveWorld,scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,ActiveWindow,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,IsPixmap,
     +     screen_width,screen_height,lastcolourcode,lastcolourset
      character lastcolourname*80
      common /CommonWindowChar/ lastcolourname
      logical display_activated
      integer loglevel
      common /CommonWindowData/ display_activated,loglevel
      integer maxpoint
      parameter (maxpoint=1000)
      integer*2 xy(2*maxpoint)
      integer ipoint
      common /window_points/ ipoint,xy
      external windowdata
      integer w
      if(ActiveWorld.lt.0) then
        call WindowCannot('WorldToWindow')
        return
      endif
      nx = nint(scalx(ActiveWorld)*(x-offsx(ActiveWorld)))
      ny = nint(scaly(ActiveWorld)*(y-offsy(ActiveWorld)))
      w = WorldParent(ActiveWorld)
      ny = (WindowHeight(w)- ny)
      return
      end                       ! WorldToWindow
